/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   libftprintf.h                                      :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: cchauvet <cchauvet@student.42angoulem      +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2022/09/26 14:47:54 by cchauvet          #+#    #+#             */
/*   Updated: 2022/10/07 01:37:57 by cchauvet         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#ifndef LIBFTPRINTF_H
# define LIBFTPRINTF_H
# include <stdlib.h>
# include <unistd.h>
# include <stdarg.h>

char	*ft_strndup(const char *s, size_t n);
size_t	ft_strlen(const char *s);
char	*ft_strchr(const char *s, int c);

char	*ft_itoa(int n);
char	*ft_ctoa(int c);
char	*ft_strdup(char *s);
char	*ft_ptoa(void *ptr);
char	*ft_utoa(unsigned int n);
char	*ft_itoabase(int n, char *base);

int		ft_printf(const char *format, ...);

int		ft_vprintf(const char *format, va_list va);
char	*ft_vsprintf(char *str, const char *format, va_list va);
char	*ft_vdprintf(int fd, const char *format, va_list va);

void	ft_putchar_fd(char c, int fd);
void	ft_putstr_fd(char *s, int f);

#endif
